diff --git a/app/test/test_gen.c b/app/test/test_gen.c
index ceacd8c7c4..b60ceaef8a 100644
--- a/app/test/test_gen.c
+++ b/app/test/test_gen.c
@@ -5,6 +5,7 @@
 #include <rte_common.h>
 #include <rte_gen.h>
 #include <rte_mbuf.h>
+#include <rte_random.h>
 
 #include "test.h"
 
@@ -75,6 +76,37 @@ test_gen_loop_rxtx(void)
 
 		total_sent += nb_tx;
 	}
+	rte_gen_destroy(gen);
+	return 0;
+}
+
+static int
+test_gen_packet_set_raw(void)
+{
+	struct rte_gen *gen = rte_gen_create(mp);
+	TEST_ASSERT_FAIL(gen, "Expected valid pointer after create()");
+
+	/* Set a raw packet payload, and ensure the next received packet has
+	 * that packet data as contents and size.
+	 */
+	uint64_t pkt_data[8];
+	uint32_t i;
+	for (i = 0; i < 8; i++)
+		pkt_data[i] = rte_rand();
+
+	int32_t err = rte_gen_packet_set_raw(gen, (void *)pkt_data, 64);
+	TEST_ASSERT_EQUAL(err, 0, "Expected set raw() to return success.");
+
+	struct rte_mbuf *bufs[BURST_MAX];
+	uint16_t nb_rx = rte_gen_rx_burst(gen, bufs, 1);
+	TEST_ASSERT_EQUAL(nb_rx, 1, "Expected rx packet burst.");
+
+	void *mbuf_data = rte_pktmbuf_mtod(bufs[0], void *);
+	int32_t data_equal = memcmp(pkt_data, mbuf_data, 64) == 0;
+	TEST_ASSERT_EQUAL(data_equal, 1,
+		"Expected packet data equal to input data.");
+
+	rte_pktmbuf_free(bufs[0]);
 
 	rte_gen_destroy(gen);
 	return 0;
@@ -88,6 +120,7 @@ static struct unit_test_suite gen_suite  = {
 		TEST_CASE_ST(NULL, NULL, test_gen_create),
 		TEST_CASE_ST(NULL, NULL, test_gen_basic_rxtx),
 		TEST_CASE_ST(NULL, NULL, test_gen_loop_rxtx),
+		TEST_CASE_ST(NULL, NULL, test_gen_packet_set_raw),
 		TEST_CASES_END() /**< NULL terminate unit test array */
 	}
 };
diff --git a/lib/gen/rte_gen.c b/lib/gen/rte_gen.c
index f0ad57fa81..8a54c4bcdb 100644
--- a/lib/gen/rte_gen.c
+++ b/lib/gen/rte_gen.c
@@ -6,13 +6,25 @@
 
 #include <rte_mbuf.h>
 #include <rte_malloc.h>
+#include <rte_hexdump.h>
+#include <rte_log.h>
+
+RTE_LOG_REGISTER(gen_logtype, lib.gen, NOTICE);
+
+#define GEN_LOG(level, fmt, args...)				\
+	rte_log(RTE_LOG_ ## level, gen_logtype, "%s(): " fmt,	\
+		__func__, ## args)
 
 #define GEN_MAX_BURST 32
+#define GEN_INIT_PKT_SIZE 64
 
 /** Structure that represents a traffic generator. */
 struct rte_gen {
 	/* Mempool that buffers are retrieved from. */
 	struct rte_mempool *mp;
+
+	/* Packet template to send. */
+	struct rte_mbuf *base_pkt;
 };
 
 /* Allocate and initialize a traffic generator instance. */
@@ -25,6 +37,15 @@ rte_gen_create(struct rte_mempool *mempool)
 
 	gen->mp = mempool;
 
+	uint8_t data[GEN_INIT_PKT_SIZE];
+	memset(data, 0, GEN_INIT_PKT_SIZE);
+	int32_t err = rte_gen_packet_set_raw(gen, data, GEN_INIT_PKT_SIZE);
+	if (err) {
+		GEN_LOG(ERR, "Failed to set initial packet\n");
+		rte_free(gen);
+		return NULL;
+	}
+
 	return gen;
 }
 
@@ -32,9 +53,37 @@ rte_gen_create(struct rte_mempool *mempool)
 void
 rte_gen_destroy(struct rte_gen *gen)
 {
+	rte_pktmbuf_free(gen->base_pkt);
 	rte_free(gen);
 }
 
+int32_t
+rte_gen_packet_set_raw(struct rte_gen *gen,
+		       const uint8_t *raw_data,
+		       uint32_t raw_data_size)
+{
+
+	struct rte_mbuf *new_pkt = rte_pktmbuf_alloc(gen->mp);
+	if (!new_pkt) {
+		GEN_LOG(ERR, "Failed to retireve mbuf for parser\n");
+		return -ENOMEM;
+	}
+
+	uint8_t *base_data = rte_pktmbuf_mtod(new_pkt, uint8_t *);
+	new_pkt->pkt_len = raw_data_size;
+	new_pkt->data_len = raw_data_size;
+	rte_memcpy(base_data, raw_data, raw_data_size);
+
+	/* If old packet exists, free it. */
+	struct rte_mbuf *old_pkt = gen->base_pkt;
+	gen->base_pkt = new_pkt;
+
+	if (old_pkt)
+		rte_pktmbuf_free(old_pkt);
+
+	return 0;
+}
+
 uint16_t
 rte_gen_rx_burst(struct rte_gen *gen,
 		 struct rte_mbuf **rx_pkts,
@@ -45,17 +94,20 @@ rte_gen_rx_burst(struct rte_gen *gen,
 	if (err)
 		return 0;
 
-	const uint32_t pkt_len = 64;
+	if (!gen->base_pkt)
+		return 0;
+
+	const uint32_t base_size = gen->base_pkt->pkt_len;
+	const uint8_t *base_data = rte_pktmbuf_mtod(gen->base_pkt, uint8_t *);
 
 	uint32_t i;
 	for (i = 0; i < nb_pkts; i++) {
 		struct rte_mbuf *m = rx_pkts[i];
 		uint8_t *pkt_data = rte_pktmbuf_mtod(m, uint8_t *);
 
-		memset(pkt_data, 0, pkt_len);
-
-		m->pkt_len  = pkt_len;
-		m->data_len = pkt_len;
+		rte_memcpy(pkt_data, base_data, base_size);
+		m->pkt_len = base_size;
+		m->data_len = base_size;
 	}
 
 	return nb_pkts;
diff --git a/lib/gen/rte_gen.h b/lib/gen/rte_gen.h
index 09ee1e8872..9119331673 100644
--- a/lib/gen/rte_gen.h
+++ b/lib/gen/rte_gen.h
@@ -85,6 +85,15 @@ rte_gen_tx_burst(struct rte_gen *gen,
 		 uint64_t *pkt_latencies,
 		 const uint16_t nb_pkts);
 
+/* Update the packet being sent to the provided raw data.
+ * @retval 0 Success.
+ * @retval -ENOMEM No memory available.
+ */
+__rte_experimental
+int32_t
+rte_gen_packet_set_raw(struct rte_gen *gen,
+		       const uint8_t *raw_data,
+		       uint32_t raw_data_size);
 
 #ifdef __cplusplus
 }
diff --git a/lib/gen/version.map b/lib/gen/version.map
index bdd25add6f..d75e0b4bac 100644
--- a/lib/gen/version.map
+++ b/lib/gen/version.map
@@ -5,4 +5,5 @@ EXPERIMENTAL {
 	rte_gen_destroy;
 	rte_gen_rx_burst;
 	rte_gen_tx_burst;
+	rte_gen_packet_set_raw;
 };